//+------------------------------------------------------------------+
//|                                                        RSI_C.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_separate_window
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_buffers 3
#property indicator_color1 Khaki
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Red
//---- input parameters
extern int RSIPeriod =  14;   //  RSI
extern int RSIPrice  =  0;    //  RSI: 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern int RSILevel  =  70;   //   RSI,   100-RSILevel
      
//---- buffers
double rsi[];
double inner[];
double up[];
double lo[];
int LoLevel;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(4);
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,inner);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,up);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,lo);

   SetIndexBuffer(3,rsi);
   
   LoLevel=100-RSILevel;
   
   SetLevelValue(0,RSILevel);
   SetLevelValue(1,LoLevel);
   
   SetIndexLabel(0,"RSI");
   SetIndexLabel(1,"");   
   SetIndexLabel(2,"");     
   
   SetIndexDrawBegin(0,RSIPeriod+1);
   SetIndexDrawBegin(1,RSIPeriod+1);
   SetIndexDrawBegin(2,RSIPeriod+1);   
   
   IndicatorShortName("RSI");
   
   IndicatorDigits(2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               up[i]=EMPTY_VALUE;
               lo[i]=EMPTY_VALUE;
               up[i+1]=EMPTY_VALUE;
               lo[i+1]=EMPTY_VALUE;               
               rsi[i]=iRSI(NULL,0,RSIPeriod,RSIPrice,i);
               inner[i] = rsi[i];
               
               if (rsi[i] >= RSILevel)
               {
                  if (rsi[i + 1] < RSILevel) inner[i] = RSILevel;
                  else                       inner[i] = EMPTY_VALUE;
               }
               else 
               {
                  if (rsi[i + 1] >= RSILevel)   inner[i + 1] = RSILevel;
               }
               
               
               if (rsi[i] <= LoLevel)
               {
                  if (rsi[i + 1] > LoLevel)  inner[i] = LoLevel;
                  else                       inner[i] = EMPTY_VALUE;
               }
               else
               {
                  if (rsi[i + 1] <= LoLevel)  inner[i] = LoLevel;
               }
               
               
                  if(rsi[i]>=RSILevel){
                     up[i]=rsi[i];
                     if(rsi[i+1]>=RSILevel)  up[i+1]=rsi[i+1];
                     else                    up[i+1]=RSILevel;
                  }
                  else{
                     if(rsi[i+1]>=RSILevel){
                        up[i]=RSILevel;
                        up[i+1]=rsi[i+1];
                     }
                  }   
                  if(rsi[i+1]>=RSILevel){
                     up[i+1]=rsi[i+1];
                     if(rsi[i+2]>=RSILevel)  up[i+2]=rsi[i+2];
                     else                    up[i+2]=RSILevel;
                  }
                  else{
                     if(rsi[i+2]>=RSILevel){
                        up[i+1]=RSILevel;
                        up[i+2]=rsi[i+2];
                     }
                  }    
               
               
               
               
               
                  if(rsi[i]<=LoLevel){
                     lo[i]=rsi[i];
                     if(rsi[i+1]<=LoLevel)   lo[i+1]=rsi[i+1];
                     else                    lo[i+1]=LoLevel;
                  }
                  else{
                     if(rsi[i+1]<=LoLevel){
                        lo[i]=LoLevel;
                        lo[i+1]=rsi[i+1];
                     }
                  }   
                  if(rsi[i+1]<=LoLevel){
                     lo[i+1]=rsi[i+1];
                     if(rsi[i+2]<=LoLevel)   lo[i+2]=rsi[i+2];
                     else                    lo[i+2]=LoLevel;
                  }
                  else{
                     if(rsi[i+2]<=LoLevel){
                        lo[i+1]=LoLevel;
                        lo[i+2]=rsi[i+2];
                     }
                  }                  
               
               
               
            }
   return(0);
  }
//+------------------------------------------------------------------+